/*
 * CloseBehavior.java
 *
 * Created on 10. Mai 2003, 15:26
 */

package j3d_uebung.behavior;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import java.util.Enumeration;

public class CloseBehavior extends Behavior {
    private TransformGroup  targetTG;
    private WakeupCriterion pairPostCondition;
    private WakeupCriterion wakeupNextFrame;
    private WakeupCriterion AWTEventCondition;
    private double buchAngle;
    
    /** Creates a new instance of CloseBehavior */
    CloseBehavior(TransformGroup tg, Behavior Trigger){
        targetTG = tg;
        //Aufwachen:
        AWTEventCondition = new WakeupOnBehaviorPost(Trigger, 7); //Wenn Pick Signal gibt
        wakeupNextFrame = new WakeupOnElapsedTime(1);           //Wenn die Animation luft
    }
    
    public void setBehaviorObjectPartner(Behavior behaviorObject){
        //Behaviorpartner setzen
        //Condition tritt ein, wenn 
        //behaviorObject (OpenBehavior) die ID 1 postet        
        pairPostCondition = new WakeupOnBehaviorPost(behaviorObject, 1);
    }
    
    public void initialize(){
        //Buch zunchst geschlossen
        //Aufwachen, wenn geffnet
        this.wakeupOn(pairPostCondition);
        buchAngle = 0.0;
    }
    
    
    public void processStimulus(Enumeration criteria){
        //Wurde Nachricht vom Behaviorpartner erzeugt?
            //ja:
            //Buch wurde geffnet, bei Pick aufwachen
            //Buch ist offen
        //sonst:
            // kann MousePick oder NextFrame sein
            //Ist Buch nicht geschlossen ?
                //stimmt:
                //Buch weiter schlieen
                
                
                //"Unterlauf" des Schlieungswinkels verhindern
                
                
                // Transformationsobjekt erzeugen
                
                
                //neuen berechneten Winkel setzen (Rotation y-Achse, Winkel negativ)
                
                
                //Transformation bei Zielgruppe setzen 
                
                
                //Zeitpunkt des nchsten Aufrufes bestimmen
                
                
            //Buch ist geschlossen:
                
                //das nchste Mal aufwachen,
                //wenn Buch geffnet wurde
                
                
                //Bekanntgabe, das Buch geschlossen ist
                

    }
    
}
